﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Validating_Label
{
    public partial class ValidLabel : Label
    {
        bool valid = false;
        bool Valid
        {
            get { return valid; }
            // Label ei itse pysty aiheuttamaan Validating-tapahtumaa
            // Jos siis haluaa tarkistaa, että onko kaikki ok sijoitettaessa arvo suoraan propertyyn niin
            // on tehtävä tarkistukset erikseen
            set { valid = value; }
        }
        public ValidLabel()
        {
            InitializeComponent();

            // Lisätään validating-tapahtumaan oma käsittelijä vrt. lisääminen Design-näkymässä
            this.Validating += new CancelEventHandler(this.ValidLabel_Validating);
            Valid = false;            
        }

        // Tämä lisätty suoraan Design-näkymän tapahtumalistauksesta.
        // VS2015 näyttää metodiin liittyvät referenssit metodin nimen yläpuolella
        // Jos referenssilukema näyttää nollaa niin ei voi toimia, koska mistään ei kutsuttaisi tätä metodia
        private void ValidLabel_Validated(object sender, EventArgs e)
        {
            MessageBox.Show("Validated-tapahtumassa eli kaikki on ok");
        }

        private void ValidLabel_Validating(object sender, CancelEventArgs e)
        {
            MessageBox.Show("Validating-tapahtumassa eli tehdään tarkistuksia");
            // ei ole nyt toteutettu mitään oikeita tarkistuksia. Käännetään vain kontrollin
            // tila validista epävalidiksi ja toistepäin kts. oma attribuutti valid
            
            if (Valid)
            {   // kaikki ok
                e.Cancel = false;
                Valid = false;
                Text = "On validi";
                // tämän jälkeen tapahtuu myös Validated
            }
            else
            {
                // Jossain oli vikaa 
                e.Cancel = true;
                Valid = true;
                Text = "Ei ole validi";
                // Validated EI tapahtu
            }
        }

    }
}
